Attribute VB_Name = "basParam"
Option Explicit

' p[^L[
Public Const csTimer        As String = "Timer"
Public Const csTabKey       As String = "TabKey"
Public Const csRange        As String = "Range"
Public Const csMsMove       As String = "MsMove"

' ftHgl
Public Const ciDefTimer         As Integer = 50

' o[
Private mlTimer             As Long         ' ^C}[荞ݎ
Private mbTabKey            As Boolean      ' ^uL[
Private mlRange(4)          As Long         ' L͈
Private mbMsMove            As Boolean      ' ͈͓}EXړ

Public Property Get mrParamValue(ByVal psParamKey As String, Optional ByVal plIndex As Long) As Variant
'---------------------------------------------------------------------------
'    : mrParamValue()
' @@@\ : p[^l̎擾
' @@ : (I) psParamKey     p[^L[
'   l : p[^l
' @@ : 2002/11/21
'---------------------------------------------------------------------------
    Select Case psParamKey
    Case csTimer
        mrParamValue = mlTimer
    Case csTabKey
        mrParamValue = mbTabKey
    Case csRange
        mrParamValue = mlRange(plIndex)
    Case csMsMove
        mrParamValue = mbMsMove

    End Select
End Property

Public Property Let mrParamValue(ByVal psParamKey As String, Optional ByVal plIndex As Long, ByVal pvParamValue As Variant)
'---------------------------------------------------------------------------
'    : mrParamValue()
' @@@\ : p[^l̐ݒ
' @@ : (I) psParamKey     p[^L[
'          : (I) pvParamValue   p[^l
'   l : Ȃ
' @@ : 2002/11/21
'---------------------------------------------------------------------------
    Select Case psParamKey
    Case csTimer
        mlTimer = pvParamValue
    Case csTabKey
        mbTabKey = pvParamValue
    Case csRange
        mlRange(plIndex) = pvParamValue
    Case csMsMove
        mbMsMove = pvParamValue

    End Select
End Property

Public Function mrReadIniFile() As Boolean
'---------------------------------------------------------------------------
'    : mrReadIniFile()
' @@@\ : p[^t@Cǂݍ
' @@ : Ȃ
'   l : True= , False= s
' @@ : 2002/11/21
'---------------------------------------------------------------------------
    Dim liFileNo        As Integer          ' t@Cԍ
    Dim lsFileName      As String           ' t@C
    Dim lsLine          As String           ' ǂݍݕ
    Dim lsKeyStr        As String           ' p[^L[
    Dim liEqlPos        As Integer          ' ̈ʒu
    Dim lsPrmStr        As String           ' p[^l
    Dim lsAppPath       As String           ' AvP[ṼpX
    Dim llIndex         As Long             ' f[^i[ʒu

    On Error GoTo mrReadIniFile_Error

    lsAppPath = App.Path
    If Right(lsAppPath, 1) = "\" Then
        lsFileName = lsAppPath & App.ProductName & ".ini"
    Else
        lsFileName = lsAppPath & "\" & App.ProductName & ".ini"
    End If
    liFileNo = FreeFile

    mlTimer = ciDefTimer
    mbTabKey = False
    mlRange(0) = 0
    mlRange(1) = 0
    mlRange(2) = Screen.Width \ Screen.TwipsPerPixelX - 1
    mlRange(3) = Screen.Height \ Screen.TwipsPerPixelY - 1
    mbMsMove = True

    Open lsFileName For Input Access Read As liFileNo
    On Error Resume Next
    Do While Not EOF(liFileNo)
        Line Input #liFileNo, lsLine
        lsLine = LTrim(lsLine)
        liEqlPos = InStr(lsLine, "=")

        If liEqlPos > 0 Then
            lsKeyStr = Left$(lsLine, liEqlPos - 1)
            lsPrmStr = Mid$(lsLine, liEqlPos + 1)

            Select Case UCase(Trim(lsKeyStr))
            Case UCase(csTimer)
                mlTimer = CLng(lsPrmStr)

            Case UCase(csTabKey)
                mbTabKey = CBool(lsPrmStr)

            Case UCase(csRange)
                For llIndex = 0 To 2
                    liEqlPos = InStr(lsPrmStr, ",")
                    If liEqlPos <> 0 Then
                        mlRange(llIndex) = Left(lsPrmStr, liEqlPos - 1)
                        lsPrmStr = Mid(lsPrmStr, liEqlPos + 1)
                    End If
                Next llIndex
                If llIndex <> 0 Then
                    mlRange(3) = Right(lsPrmStr, liEqlPos + 1)
                End If

            Case UCase(csMsMove)
                mbMsMove = CBool(lsPrmStr)

            End Select
        End If
    Loop

    Close liFileNo
    mrReadIniFile = True
    Exit Function

mrReadIniFile_Error:
    Close liFileNo
    mrReadIniFile = False
End Function

Public Function mrWriteIniFile() As Boolean
'---------------------------------------------------------------------------
'    : mrWriteIniFile()
' @@@\ : ݒt@C̏
' @@ : Ȃ
'   l : True= , False= s
' @@ : 2002/11/21
'---------------------------------------------------------------------------
    Dim liFileNo        As Integer          ' t@Cԍ
    Dim lsIniFile       As String           ' ݒt@C
    Dim liRetCode       As Integer          ' ߂l
    Dim lsAppPath       As String           ' AvP[ṼpX

    On Error GoTo mrWriteIniFile_Error

    lsAppPath = App.Path
    If Right(lsAppPath, 1) = "\" Then
        lsIniFile = lsAppPath & App.ProductName & ".ini"
    Else
        lsIniFile = lsAppPath & "\" & App.ProductName & ".ini"
    End If
    liFileNo = FreeFile

    Open lsIniFile For Output Access Write As liFileNo
    Print #liFileNo, "[" & App.ProductName & "]"
    Print #liFileNo, ""

    If mlTimer <> ciDefTimer Then
        Print #liFileNo, csTimer & "=" & mlTimer
    End If
    If mbTabKey <> False Then
        Print #liFileNo, csTabKey & "=" & mbTabKey
    End If

    Print #liFileNo, csRange & "=" & mlRange(0) & ", " & mlRange(1) & ", " & mlRange(2) & ", " & mlRange(3)
    Print #liFileNo, csMsMove & "=" & mbMsMove

    Close liFileNo
    mrWriteIniFile = True
    Exit Function

mrWriteIniFile_Error:
    liRetCode = MsgBox("ݒt@C݂̏Ɏs܂B" & vbCrLf & lsIniFile, vbCritical Or vbRetryCancel, "G[")
    If liRetCode = vbRetry Then
        Resume
    End If
    Close #liFileNo
    mrWriteIniFile = False
End Function
